<template>
<div  background-color=#4E655D>
<div class="container">
  <div class="main">
        <!-- 整个注册盒子 -->
      <div class="loginbox">
          <!-- 左侧的注册盒子 -->
          <div class="loginbox-in">
            <h2 align="center"><strong>商家身份认证</strong></h2>
          <div class="userbox">
    <el-form :model="ruleForm" :rules="rules" ref="ruleForm" label-width="120px" class="demo-ruleForm">
      <el-form-item label="商家类型">
        <el-select v-model="ruleForm.value" placeholder="请选择商家类型">
          <el-option style="width:100%"
            v-for="item in options"
            :key="item.value"
            :label="item.label"
            :value="item.value"
          >
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="上传营业执照" ref="uploadElement" prop="imageUrl">
        <el-input v-model="ruleForm.imageUrl" v-if="false"></el-input>
        <el-upload
          class="avatar-uploader"
          ref="upload"
          :show-file-list="false"
          action="/index/upload"
          :before-upload="beforeUpload"
          :on-change="handleChange"
          :auto-upload="false"
          :data="ruleForm">
          <img v-if="ruleForm.imageUrl" :src="ruleForm.imageUrl" class="avatar">
          <i v-else class="el-icon-plus avatar-uploader-icon"></i>
        </el-upload>
      </el-form-item>
      <el-form-item label="上传身份证明" ref="uploadElement2" prop="imageUrl2">
        <el-input v-model="ruleForm.imageUrl2" v-if="false"></el-input>
        <el-upload
          class="avatar-uploader"
          :show-file-list="false"
          action="/index/upload"
          :before-upload="beforeUpload"
          :on-change="handleChange2"
          :auto-upload="false"
          :data="ruleForm">
          <img v-if="ruleForm.imageUrl2" :src="ruleForm.imageUrl2" class="avatar">
          <i v-else class="el-icon-plus avatar-uploader-icon"></i>
        </el-upload>
      </el-form-item>
      <el-form-item style="margin-top: 57px">
        <el-row>
          <el-col :span="12">
            <el-button type="primary" size="mini" @click="submitForm('ruleForm')" :disabled="ruleForm.disabled===true">立即申请</el-button>
          </el-col>
          <el-col :span="12">
            <el-button type="danger" size="mini" @click="resetForm('ruleForm')" :disabled="ruleForm.disabled===true">重置</el-button>
          </el-col>
        </el-row>
      </el-form-item>
    </el-form>
  </div>

        </div>
        <div class="background">
            <div class="title"></div>
      </div>
    </div>
  </div>
  </div>
  </div>
</template>

<script>

import shopRecognizeService from '../services/shopRecognizeService'
export default {
  name: 'shoprecognize',
  data () {
    return {
      ruleForm: {
        imageUrl: '',
        imageUrl2: '',
        value: 'key1',
        disabled: false
      },
      rules: {
        imageUrl: [
          {required: true, message: '请上传营业执照', trigger: 'blur'}
        ],
        imageUrl2: [
          {required: true, message: '请上传身份证明', trigger: 'blur'}
        ],
        value: [
          {required: true, message: '请选择商家类型', trigger: 'blur'}
        ]
      },
      options: [{
        value: 'key1',
        label: '健身'
      }, {
        value: 'key2',
        label: '食品'
      }]
    }
  },
  methods: {
    async submitForm (formName) {
      try {
        if (this.ruleForm.imageUrl === '' || this.ruleForm.imageUrl2 === '') {
          await this.$alert('有必填项未填！', '申请失败', {
            confirmButtonText: '确定',
            callback: action => {
              this.$message({
                type: 'info',
                message: `action: ${action}`
              })
            }
          })
          return
        }
        this.ruleForm.disabled = true
        let response
        if (this.ruleForm.value === 'key1') {
          response = await shopRecognizeService.postgym({
            userIdProof: this.ruleForm.imageUrl2,
            userQualificationProof: this.ruleForm.imageUrl,
            userName: this.$store.state.userInfo.userName
          },
          {
            headers: {'Authorization': this.$store.state.token}
          })
        } else if (this.ruleForm.value === 'key2') {
          response = await shopRecognizeService.postfood({
            userIdProof: this.ruleForm.imageUrl2,
            userQualificationProof: this.ruleForm.imageUrl,
            userName: this.$store.state.userInfo.userName
          },
          {
            headers: {'Authorization': this.$store.state.token}
          })
        }
        if (response.data.code === 200) {
          await this.$alert('商家认证申请添加成功！', '申请成功', {
            confirmButtonText: '确定',
            callback: action => {
              this.$message({
                type: 'info',
                message: `action: ${action}`
              })
              this.$router.push('/showviewinfo')
            }
          })
        } else {
          this.ruleForm.disabled = false
          this.error = response.data.msg
          await this.$alert(response.data.msg, '发送失败', {
            confirmButtonText: '确定',
            callback: action => {
              this.$message({
                type: 'info',
                message: `action: ${action}`
              })
            }
          })
        }
      } catch (error) {
        this.ruleForm.disabled = false
        if (typeof (error.response) === 'undefined' || typeof (error.response.data) === 'undefined') {
          this.error = 'Network Error'
          await this.$alert('Network Error', '发送失败', {
            confirmButtonText: '确定',
            callback: action => {
              this.$message({
                type: 'info',
                message: `action: ${action}`
              })
            }
          })
        } else {
          this.error = error.response.data.error
          if (error.response.data.code === 400) {
            let msg = `图片过大，不能超过64KB`

            if (error.response.data.msg.indexOf('too long') !== -1 &&
              error.response.data.msg.indexOf('user_qualification_proof') !== -1) {
              msg = `营业执照图片过大，不能超过64KB`
            } else if (error.response.data.msg.indexOf('too long') !== -1 &&
              error.response.data.msg.indexOf('user_id_proof') !== -1) {
              msg = `身份证明图片过大，不能超过64KB`
            }

            await this.$alert(msg, '发送失败', {
              confirmButtonText: '确定',
              callback: action => {
                this.$message({
                  type: 'info',
                  message: `action: ${action}`
                })
              }
            })
          }
        }
      }
    },
    resetForm (formName) {
      this.ruleForm.value = ''
      this.ruleForm.imageUrl = ''
      this.ruleForm.imageUrl2 = ''
    },
    handleChange (file, fileList) {
      var _this = this
      return new Promise(function (resolve, reject) {
        var reader = new FileReader()
        reader.readAsDataURL(file.raw)// 这里是最关键的一步，转换成base64
        reader.onload = function (event) {
          _this.ruleForm.imageUrl = event.target.result
          // console.log(this.ruleForm.imageUrl)
        }
      })
    },
    handleChange2 (file, fileList) {
      var _this = this
      return new Promise(function (resolve, reject) {
        var reader = new FileReader()
        reader.readAsDataURL(file.raw)// 这里是最关键的一步，转换成base64
        reader.onload = function (event) {
          _this.ruleForm.imageUrl2 = event.target.result
          // console.log(this.ruleForm.imageUrl2)
        }
      })
    },
    beforeUpload (file) {

    },
    beforeUpload2 (file) {

    }
  }
}
</script>
<style scoped>

.demo-ruleForm {
  max-width: 500px;
  margin: 0 auto;
}
.avatar-uploader-icon {
  font-size: 28px;
  color: #8c939d;
  width: 178px;
  height: 130px;
  line-height: 130px;
  text-align: center;
}

.avatar {
  width: 178px;
  height: 130px;
  display: block;
}

.avatar-uploader .el-upload {
  border: 1px dashed #d9d9d9;
  border-radius: 6px;
  cursor: pointer;
  position: relative;
  overflow: hidden;
}

.avatar-uploader .el-upload:hover {
  border-color: #409EFF;
}

.loginbox{
    display:flex;
    position:absolute;
    width:1000px;
    height:650px;
    top:42%;
    left:50%;
    transform:translate(-50%,-50%);
    box-shadow: 0 12px 16px 0  rgba(0,0,0,0.24), 0 17px 50px 0 #4E655D;
}
.loginbox-in{
     background-color:#dee0f5;
     width:400px;
}
.userbox{
    margin-top:60px ;
    height:30px;
     width:230px;
     display: flex;
     margin-left:25px;
}
.pwdbox{
    height:30px;
    width:225px;
    display: flex;
    margin-left:25px;
}

.background{
    width:600px;
    background-size:cover;
    background-image:url('../assets/food2.jpg');
    font-family:sans-serif;
}
.title{
    margin-top:320px;
    font-weight:bold;
    font-size:20px;
    color:#4E655D;

}
.title:hover{
     font-size:21px;
     transition: all 0.4s ease-in-out;
     cursor: pointer;
}

input{
    outline-style: none ;
    border: 0;
    border-bottom:1px solid #E9E9E9;
    background-color:transparent;
    height:20px;
    font-family:sans-serif;
    font-size:15px;
    color:#445b53;
    font-weight:bold;
}
 /* input::-webkit-input-placeholder{
    color:#E9E9E9;
 } */
.el-select {
  width: 200px;
}
input:focus{
    border-bottom:2px solid #445b53;
    background-color:transparent;
     transition: all 0.2s ease-in;
     font-family:sans-serif;
    font-size:15px;
     color:#445b53;
     font-weight:bold;

}
input:hover{
    border-bottom:2px solid #445b53;
    background-color:transparent;
     transition: all 0.2s ease-in;
     font-family:sans-serif;
    font-size:15px;
     color:#445b53;
     font-weight:bold;
     width:100%;
}

input:-webkit-autofill {
  /* 修改默认背景框的颜色 */
 box-shadow: 0 0 0px 1000px  #87CEFA inset !important;
 /* 修改默认字体的颜色 */
 -webkit-text-fill-color: #445b53;
}

input:-webkit-autofill::first-line {
  /* 修改默认字体的大小 */
 font-size: 15px;
 /* 修改默认字体的样式 */
 font-weight:bold;
 }
.log-box{
    font-size:12px;
    display: flex;
    justify-content: space-between ;
    width:190px;
    margin-left:300px;
    color:#4E655D;
    margin-top:-5px;
    align-items: center;
}
.log-box-text{
    color:#4E655D;
    font-size:12px;
      text-decoration:underline;
    }
.login_btn{
    background-color: #5f8276; /* Green */
    border: none;
    color: #FAFAFA;
    padding: 5px 22px;
    text-align: center;
    text-decoration: none;
    font-size: 13px;
    border-radius: 25px;
    outline:none;
}
.login_btn:hover{
    box-shadow: 0 12px 16px 0 rgba(0,0,0,0.24), 0 17px 50px 0 rgba(0,0,0,0.19);
    cursor: pointer;
     background-color: #0b5137;
      transition: all 0.2s ease-in;
}

.warn{
    margin-top:60px;
    /* margin-right:120px; */
    margin-left:-120px;
    margin-bottom: 5px;
     font-weight:bold;
    font-size:17px;
}

.register_btn{
    border: none;
    text-decoration: none;
    font-size: 12px;
    /* border-radius: 20px;   */
     color:#4E655D;
    font-size:12px;
    display: flex;
    margin-left:5px;
    text-align: center;
    outline:none;
}
.register_btn:hover{
    font-weight:bold;
    cursor: pointer;
}

.iconfont {
    font-family: "iconfont" !important;
    font-size: 20px;
    font-style: normal;
    -webkit-font-smoothing: antialiased;
    -moz-osx-font-smoothing: grayscale;
    height:22px;
    color:#4E655D;
    margin-right:10px;
    margin-top:3px;
}

.icon-key:before {
    content: "\e775";
}

.icon-account:before {
    content: "\e817";
}
</style>
